// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"

	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/valocode/bubbly/ent/codeissue"

	"github.com/valocode/bubbly/ent/codescan"
	schema "github.com/valocode/bubbly/ent/schema/types"
)

// CodeIssueCreate is the builder for creating a CodeIssue entity.
type CodeIssueCreate struct {
	config
	mutation *CodeIssueMutation
	hooks    []Hook
}

// SetRuleID sets the "rule_id" field.
func (cic *CodeIssueCreate) SetRuleID(s string) *CodeIssueCreate {
	cic.mutation.SetRuleID(s)
	return cic
}

// SetMessage sets the "message" field.
func (cic *CodeIssueCreate) SetMessage(s string) *CodeIssueCreate {
	cic.mutation.SetMessage(s)
	return cic
}

// SetSeverity sets the "severity" field.
func (cic *CodeIssueCreate) SetSeverity(c codeissue.Severity) *CodeIssueCreate {
	cic.mutation.SetSeverity(c)
	return cic
}

// SetType sets the "type" field.
func (cic *CodeIssueCreate) SetType(c codeissue.Type) *CodeIssueCreate {
	cic.mutation.SetType(c)
	return cic
}

// SetMetadata sets the "metadata" field.
func (cic *CodeIssueCreate) SetMetadata(s schema.Metadata) *CodeIssueCreate {
	cic.mutation.SetMetadata(s)
	return cic
}

// SetScanID sets the "scan" edge to the CodeScan entity by ID.
func (cic *CodeIssueCreate) SetScanID(id int) *CodeIssueCreate {
	cic.mutation.SetScanID(id)
	return cic
}

// SetScan sets the "scan" edge to the CodeScan entity.
func (cic *CodeIssueCreate) SetScan(c *CodeScan) *CodeIssueCreate {
	return cic.SetScanID(c.ID)
}

// Mutation returns the CodeIssueMutation object of the builder.
func (cic *CodeIssueCreate) Mutation() *CodeIssueMutation {
	return cic.mutation
}

// Save creates the CodeIssue in the database.
func (cic *CodeIssueCreate) Save(ctx context.Context) (*CodeIssue, error) {
	var (
		err  error
		node *CodeIssue
	)
	if len(cic.hooks) == 0 {
		if err = cic.check(); err != nil {
			return nil, err
		}
		node, err = cic.sqlSave(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*CodeIssueMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			if err = cic.check(); err != nil {
				return nil, err
			}
			cic.mutation = mutation
			if node, err = cic.sqlSave(ctx); err != nil {
				return nil, err
			}
			mutation.id = &node.ID
			mutation.done = true
			return node, err
		})
		for i := len(cic.hooks) - 1; i >= 0; i-- {
			if cic.hooks[i] == nil {
				return nil, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = cic.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, cic.mutation); err != nil {
			return nil, err
		}
	}
	return node, err
}

// SaveX calls Save and panics if Save returns an error.
func (cic *CodeIssueCreate) SaveX(ctx context.Context) *CodeIssue {
	v, err := cic.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (cic *CodeIssueCreate) Exec(ctx context.Context) error {
	_, err := cic.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (cic *CodeIssueCreate) ExecX(ctx context.Context) {
	if err := cic.Exec(ctx); err != nil {
		panic(err)
	}
}

// check runs all checks and user-defined validators on the builder.
func (cic *CodeIssueCreate) check() error {
	if _, ok := cic.mutation.RuleID(); !ok {
		return &ValidationError{Name: "rule_id", err: errors.New(`ent: missing required field "rule_id"`)}
	}
	if v, ok := cic.mutation.RuleID(); ok {
		if err := codeissue.RuleIDValidator(v); err != nil {
			return &ValidationError{Name: "rule_id", err: fmt.Errorf(`ent: validator failed for field "rule_id": %w`, err)}
		}
	}
	if _, ok := cic.mutation.Message(); !ok {
		return &ValidationError{Name: "message", err: errors.New(`ent: missing required field "message"`)}
	}
	if v, ok := cic.mutation.Message(); ok {
		if err := codeissue.MessageValidator(v); err != nil {
			return &ValidationError{Name: "message", err: fmt.Errorf(`ent: validator failed for field "message": %w`, err)}
		}
	}
	if _, ok := cic.mutation.Severity(); !ok {
		return &ValidationError{Name: "severity", err: errors.New(`ent: missing required field "severity"`)}
	}
	if v, ok := cic.mutation.Severity(); ok {
		if err := codeissue.SeverityValidator(v); err != nil {
			return &ValidationError{Name: "severity", err: fmt.Errorf(`ent: validator failed for field "severity": %w`, err)}
		}
	}
	if _, ok := cic.mutation.GetType(); !ok {
		return &ValidationError{Name: "type", err: errors.New(`ent: missing required field "type"`)}
	}
	if v, ok := cic.mutation.GetType(); ok {
		if err := codeissue.TypeValidator(v); err != nil {
			return &ValidationError{Name: "type", err: fmt.Errorf(`ent: validator failed for field "type": %w`, err)}
		}
	}
	if _, ok := cic.mutation.ScanID(); !ok {
		return &ValidationError{Name: "scan", err: errors.New("ent: missing required edge \"scan\"")}
	}
	return nil
}

func (cic *CodeIssueCreate) sqlSave(ctx context.Context) (*CodeIssue, error) {
	_node, _spec := cic.createSpec()
	if err := sqlgraph.CreateNode(ctx, cic.driver, _spec); err != nil {
		if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{err.Error(), err}
		}
		return nil, err
	}
	id := _spec.ID.Value.(int64)
	_node.ID = int(id)
	return _node, nil
}

func (cic *CodeIssueCreate) createSpec() (*CodeIssue, *sqlgraph.CreateSpec) {
	var (
		_node = &CodeIssue{config: cic.config}
		_spec = &sqlgraph.CreateSpec{
			Table: codeissue.Table,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: codeissue.FieldID,
			},
		}
	)
	if value, ok := cic.mutation.RuleID(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: codeissue.FieldRuleID,
		})
		_node.RuleID = value
	}
	if value, ok := cic.mutation.Message(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: codeissue.FieldMessage,
		})
		_node.Message = value
	}
	if value, ok := cic.mutation.Severity(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeEnum,
			Value:  value,
			Column: codeissue.FieldSeverity,
		})
		_node.Severity = value
	}
	if value, ok := cic.mutation.GetType(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeEnum,
			Value:  value,
			Column: codeissue.FieldType,
		})
		_node.Type = value
	}
	if value, ok := cic.mutation.Metadata(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeJSON,
			Value:  value,
			Column: codeissue.FieldMetadata,
		})
		_node.Metadata = value
	}
	if nodes := cic.mutation.ScanIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: false,
			Table:   codeissue.ScanTable,
			Columns: []string{codeissue.ScanColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeInt,
					Column: codescan.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_node.code_issue_scan = &nodes[0]
		_spec.Edges = append(_spec.Edges, edge)
	}
	return _node, _spec
}

// CodeIssueCreateBulk is the builder for creating many CodeIssue entities in bulk.
type CodeIssueCreateBulk struct {
	config
	builders []*CodeIssueCreate
}

// Save creates the CodeIssue entities in the database.
func (cicb *CodeIssueCreateBulk) Save(ctx context.Context) ([]*CodeIssue, error) {
	specs := make([]*sqlgraph.CreateSpec, len(cicb.builders))
	nodes := make([]*CodeIssue, len(cicb.builders))
	mutators := make([]Mutator, len(cicb.builders))
	for i := range cicb.builders {
		func(i int, root context.Context) {
			builder := cicb.builders[i]
			var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
				mutation, ok := m.(*CodeIssueMutation)
				if !ok {
					return nil, fmt.Errorf("unexpected mutation type %T", m)
				}
				if err := builder.check(); err != nil {
					return nil, err
				}
				builder.mutation = mutation
				nodes[i], specs[i] = builder.createSpec()
				var err error
				if i < len(mutators)-1 {
					_, err = mutators[i+1].Mutate(root, cicb.builders[i+1].mutation)
				} else {
					spec := &sqlgraph.BatchCreateSpec{Nodes: specs}
					// Invoke the actual operation on the latest mutation in the chain.
					if err = sqlgraph.BatchCreate(ctx, cicb.driver, spec); err != nil {
						if sqlgraph.IsConstraintError(err) {
							err = &ConstraintError{err.Error(), err}
						}
					}
				}
				if err != nil {
					return nil, err
				}
				mutation.id = &nodes[i].ID
				mutation.done = true
				if specs[i].ID.Value != nil {
					id := specs[i].ID.Value.(int64)
					nodes[i].ID = int(id)
				}
				return nodes[i], nil
			})
			for i := len(builder.hooks) - 1; i >= 0; i-- {
				mut = builder.hooks[i](mut)
			}
			mutators[i] = mut
		}(i, ctx)
	}
	if len(mutators) > 0 {
		if _, err := mutators[0].Mutate(ctx, cicb.builders[0].mutation); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

// SaveX is like Save, but panics if an error occurs.
func (cicb *CodeIssueCreateBulk) SaveX(ctx context.Context) []*CodeIssue {
	v, err := cicb.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (cicb *CodeIssueCreateBulk) Exec(ctx context.Context) error {
	_, err := cicb.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (cicb *CodeIssueCreateBulk) ExecX(ctx context.Context) {
	if err := cicb.Exec(ctx); err != nil {
		panic(err)
	}
}
