// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/valocode/bubbly/ent/predicate"
	"github.com/valocode/bubbly/ent/releasecomponent"
)

// ReleaseComponentDelete is the builder for deleting a ReleaseComponent entity.
type ReleaseComponentDelete struct {
	config
	hooks    []Hook
	mutation *ReleaseComponentMutation
}

// Where appends a list predicates to the ReleaseComponentDelete builder.
func (rcd *ReleaseComponentDelete) Where(ps ...predicate.ReleaseComponent) *ReleaseComponentDelete {
	rcd.mutation.Where(ps...)
	return rcd
}

// Exec executes the deletion query and returns how many vertices were deleted.
func (rcd *ReleaseComponentDelete) Exec(ctx context.Context) (int, error) {
	var (
		err      error
		affected int
	)
	if len(rcd.hooks) == 0 {
		affected, err = rcd.sqlExec(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*ReleaseComponentMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			rcd.mutation = mutation
			affected, err = rcd.sqlExec(ctx)
			mutation.done = true
			return affected, err
		})
		for i := len(rcd.hooks) - 1; i >= 0; i-- {
			if rcd.hooks[i] == nil {
				return 0, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = rcd.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, rcd.mutation); err != nil {
			return 0, err
		}
	}
	return affected, err
}

// ExecX is like Exec, but panics if an error occurs.
func (rcd *ReleaseComponentDelete) ExecX(ctx context.Context) int {
	n, err := rcd.Exec(ctx)
	if err != nil {
		panic(err)
	}
	return n
}

func (rcd *ReleaseComponentDelete) sqlExec(ctx context.Context) (int, error) {
	_spec := &sqlgraph.DeleteSpec{
		Node: &sqlgraph.NodeSpec{
			Table: releasecomponent.Table,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: releasecomponent.FieldID,
			},
		},
	}
	if ps := rcd.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return sqlgraph.DeleteNodes(ctx, rcd.driver, _spec)
}

// ReleaseComponentDeleteOne is the builder for deleting a single ReleaseComponent entity.
type ReleaseComponentDeleteOne struct {
	rcd *ReleaseComponentDelete
}

// Exec executes the deletion query.
func (rcdo *ReleaseComponentDeleteOne) Exec(ctx context.Context) error {
	n, err := rcdo.rcd.Exec(ctx)
	switch {
	case err != nil:
		return err
	case n == 0:
		return &NotFoundError{releasecomponent.Label}
	default:
		return nil
	}
}

// ExecX is like Exec, but panics if an error occurs.
func (rcdo *ReleaseComponentDeleteOne) ExecX(ctx context.Context) {
	rcdo.rcd.ExecX(ctx)
}
