// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/valocode/bubbly/ent/predicate"
	"github.com/valocode/bubbly/ent/spdxlicense"
)

// SPDXLicenseDelete is the builder for deleting a SPDXLicense entity.
type SPDXLicenseDelete struct {
	config
	hooks    []Hook
	mutation *SPDXLicenseMutation
}

// Where appends a list predicates to the SPDXLicenseDelete builder.
func (sld *SPDXLicenseDelete) Where(ps ...predicate.SPDXLicense) *SPDXLicenseDelete {
	sld.mutation.Where(ps...)
	return sld
}

// Exec executes the deletion query and returns how many vertices were deleted.
func (sld *SPDXLicenseDelete) Exec(ctx context.Context) (int, error) {
	var (
		err      error
		affected int
	)
	if len(sld.hooks) == 0 {
		affected, err = sld.sqlExec(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*SPDXLicenseMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			sld.mutation = mutation
			affected, err = sld.sqlExec(ctx)
			mutation.done = true
			return affected, err
		})
		for i := len(sld.hooks) - 1; i >= 0; i-- {
			if sld.hooks[i] == nil {
				return 0, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = sld.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, sld.mutation); err != nil {
			return 0, err
		}
	}
	return affected, err
}

// ExecX is like Exec, but panics if an error occurs.
func (sld *SPDXLicenseDelete) ExecX(ctx context.Context) int {
	n, err := sld.Exec(ctx)
	if err != nil {
		panic(err)
	}
	return n
}

func (sld *SPDXLicenseDelete) sqlExec(ctx context.Context) (int, error) {
	_spec := &sqlgraph.DeleteSpec{
		Node: &sqlgraph.NodeSpec{
			Table: spdxlicense.Table,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: spdxlicense.FieldID,
			},
		},
	}
	if ps := sld.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return sqlgraph.DeleteNodes(ctx, sld.driver, _spec)
}

// SPDXLicenseDeleteOne is the builder for deleting a single SPDXLicense entity.
type SPDXLicenseDeleteOne struct {
	sld *SPDXLicenseDelete
}

// Exec executes the deletion query.
func (sldo *SPDXLicenseDeleteOne) Exec(ctx context.Context) error {
	n, err := sldo.sld.Exec(ctx)
	switch {
	case err != nil:
		return err
	case n == 0:
		return &NotFoundError{spdxlicense.Label}
	default:
		return nil
	}
}

// ExecX is like Exec, but panics if an error occurs.
func (sldo *SPDXLicenseDeleteOne) ExecX(ctx context.Context) {
	sldo.sld.ExecX(ctx)
}
