// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"math"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/valocode/bubbly/ent/predicate"
	"github.com/valocode/bubbly/ent/spdxlicense"
)

// SPDXLicenseQuery is the builder for querying SPDXLicense entities.
type SPDXLicenseQuery struct {
	config
	limit      *int
	offset     *int
	unique     *bool
	order      []OrderFunc
	fields     []string
	predicates []predicate.SPDXLicense
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Where adds a new predicate for the SPDXLicenseQuery builder.
func (slq *SPDXLicenseQuery) Where(ps ...predicate.SPDXLicense) *SPDXLicenseQuery {
	slq.predicates = append(slq.predicates, ps...)
	return slq
}

// Limit adds a limit step to the query.
func (slq *SPDXLicenseQuery) Limit(limit int) *SPDXLicenseQuery {
	slq.limit = &limit
	return slq
}

// Offset adds an offset step to the query.
func (slq *SPDXLicenseQuery) Offset(offset int) *SPDXLicenseQuery {
	slq.offset = &offset
	return slq
}

// Unique configures the query builder to filter duplicate records on query.
// By default, unique is set to true, and can be disabled using this method.
func (slq *SPDXLicenseQuery) Unique(unique bool) *SPDXLicenseQuery {
	slq.unique = &unique
	return slq
}

// Order adds an order step to the query.
func (slq *SPDXLicenseQuery) Order(o ...OrderFunc) *SPDXLicenseQuery {
	slq.order = append(slq.order, o...)
	return slq
}

// First returns the first SPDXLicense entity from the query.
// Returns a *NotFoundError when no SPDXLicense was found.
func (slq *SPDXLicenseQuery) First(ctx context.Context) (*SPDXLicense, error) {
	nodes, err := slq.Limit(1).All(ctx)
	if err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nil, &NotFoundError{spdxlicense.Label}
	}
	return nodes[0], nil
}

// FirstX is like First, but panics if an error occurs.
func (slq *SPDXLicenseQuery) FirstX(ctx context.Context) *SPDXLicense {
	node, err := slq.First(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return node
}

// FirstID returns the first SPDXLicense ID from the query.
// Returns a *NotFoundError when no SPDXLicense ID was found.
func (slq *SPDXLicenseQuery) FirstID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = slq.Limit(1).IDs(ctx); err != nil {
		return
	}
	if len(ids) == 0 {
		err = &NotFoundError{spdxlicense.Label}
		return
	}
	return ids[0], nil
}

// FirstIDX is like FirstID, but panics if an error occurs.
func (slq *SPDXLicenseQuery) FirstIDX(ctx context.Context) int {
	id, err := slq.FirstID(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return id
}

// Only returns a single SPDXLicense entity found by the query, ensuring it only returns one.
// Returns a *NotSingularError when exactly one SPDXLicense entity is not found.
// Returns a *NotFoundError when no SPDXLicense entities are found.
func (slq *SPDXLicenseQuery) Only(ctx context.Context) (*SPDXLicense, error) {
	nodes, err := slq.Limit(2).All(ctx)
	if err != nil {
		return nil, err
	}
	switch len(nodes) {
	case 1:
		return nodes[0], nil
	case 0:
		return nil, &NotFoundError{spdxlicense.Label}
	default:
		return nil, &NotSingularError{spdxlicense.Label}
	}
}

// OnlyX is like Only, but panics if an error occurs.
func (slq *SPDXLicenseQuery) OnlyX(ctx context.Context) *SPDXLicense {
	node, err := slq.Only(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// OnlyID is like Only, but returns the only SPDXLicense ID in the query.
// Returns a *NotSingularError when exactly one SPDXLicense ID is not found.
// Returns a *NotFoundError when no entities are found.
func (slq *SPDXLicenseQuery) OnlyID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = slq.Limit(2).IDs(ctx); err != nil {
		return
	}
	switch len(ids) {
	case 1:
		id = ids[0]
	case 0:
		err = &NotFoundError{spdxlicense.Label}
	default:
		err = &NotSingularError{spdxlicense.Label}
	}
	return
}

// OnlyIDX is like OnlyID, but panics if an error occurs.
func (slq *SPDXLicenseQuery) OnlyIDX(ctx context.Context) int {
	id, err := slq.OnlyID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// All executes the query and returns a list of SPDXLicenses.
func (slq *SPDXLicenseQuery) All(ctx context.Context) ([]*SPDXLicense, error) {
	if err := slq.prepareQuery(ctx); err != nil {
		return nil, err
	}
	return slq.sqlAll(ctx)
}

// AllX is like All, but panics if an error occurs.
func (slq *SPDXLicenseQuery) AllX(ctx context.Context) []*SPDXLicense {
	nodes, err := slq.All(ctx)
	if err != nil {
		panic(err)
	}
	return nodes
}

// IDs executes the query and returns a list of SPDXLicense IDs.
func (slq *SPDXLicenseQuery) IDs(ctx context.Context) ([]int, error) {
	var ids []int
	if err := slq.Select(spdxlicense.FieldID).Scan(ctx, &ids); err != nil {
		return nil, err
	}
	return ids, nil
}

// IDsX is like IDs, but panics if an error occurs.
func (slq *SPDXLicenseQuery) IDsX(ctx context.Context) []int {
	ids, err := slq.IDs(ctx)
	if err != nil {
		panic(err)
	}
	return ids
}

// Count returns the count of the given query.
func (slq *SPDXLicenseQuery) Count(ctx context.Context) (int, error) {
	if err := slq.prepareQuery(ctx); err != nil {
		return 0, err
	}
	return slq.sqlCount(ctx)
}

// CountX is like Count, but panics if an error occurs.
func (slq *SPDXLicenseQuery) CountX(ctx context.Context) int {
	count, err := slq.Count(ctx)
	if err != nil {
		panic(err)
	}
	return count
}

// Exist returns true if the query has elements in the graph.
func (slq *SPDXLicenseQuery) Exist(ctx context.Context) (bool, error) {
	if err := slq.prepareQuery(ctx); err != nil {
		return false, err
	}
	return slq.sqlExist(ctx)
}

// ExistX is like Exist, but panics if an error occurs.
func (slq *SPDXLicenseQuery) ExistX(ctx context.Context) bool {
	exist, err := slq.Exist(ctx)
	if err != nil {
		panic(err)
	}
	return exist
}

// Clone returns a duplicate of the SPDXLicenseQuery builder, including all associated steps. It can be
// used to prepare common query builders and use them differently after the clone is made.
func (slq *SPDXLicenseQuery) Clone() *SPDXLicenseQuery {
	if slq == nil {
		return nil
	}
	return &SPDXLicenseQuery{
		config:     slq.config,
		limit:      slq.limit,
		offset:     slq.offset,
		order:      append([]OrderFunc{}, slq.order...),
		predicates: append([]predicate.SPDXLicense{}, slq.predicates...),
		// clone intermediate query.
		sql:  slq.sql.Clone(),
		path: slq.path,
	}
}

// GroupBy is used to group vertices by one or more fields/columns.
// It is often used with aggregate functions, like: count, max, mean, min, sum.
//
// Example:
//
//	var v []struct {
//		LicenseID string `json:"license_id,omitempty"`
//		Count int `json:"count,omitempty"`
//	}
//
//	client.SPDXLicense.Query().
//		GroupBy(spdxlicense.FieldLicenseID).
//		Aggregate(ent.Count()).
//		Scan(ctx, &v)
//
func (slq *SPDXLicenseQuery) GroupBy(field string, fields ...string) *SPDXLicenseGroupBy {
	group := &SPDXLicenseGroupBy{config: slq.config}
	group.fields = append([]string{field}, fields...)
	group.path = func(ctx context.Context) (prev *sql.Selector, err error) {
		if err := slq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		return slq.sqlQuery(ctx), nil
	}
	return group
}

// Select allows the selection one or more fields/columns for the given query,
// instead of selecting all fields in the entity.
//
// Example:
//
//	var v []struct {
//		LicenseID string `json:"license_id,omitempty"`
//	}
//
//	client.SPDXLicense.Query().
//		Select(spdxlicense.FieldLicenseID).
//		Scan(ctx, &v)
//
func (slq *SPDXLicenseQuery) Select(fields ...string) *SPDXLicenseSelect {
	slq.fields = append(slq.fields, fields...)
	return &SPDXLicenseSelect{SPDXLicenseQuery: slq}
}

func (slq *SPDXLicenseQuery) prepareQuery(ctx context.Context) error {
	for _, f := range slq.fields {
		if !spdxlicense.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
		}
	}
	if slq.path != nil {
		prev, err := slq.path(ctx)
		if err != nil {
			return err
		}
		slq.sql = prev
	}
	return nil
}

func (slq *SPDXLicenseQuery) sqlAll(ctx context.Context) ([]*SPDXLicense, error) {
	var (
		nodes = []*SPDXLicense{}
		_spec = slq.querySpec()
	)
	_spec.ScanValues = func(columns []string) ([]interface{}, error) {
		node := &SPDXLicense{config: slq.config}
		nodes = append(nodes, node)
		return node.scanValues(columns)
	}
	_spec.Assign = func(columns []string, values []interface{}) error {
		if len(nodes) == 0 {
			return fmt.Errorf("ent: Assign called without calling ScanValues")
		}
		node := nodes[len(nodes)-1]
		return node.assignValues(columns, values)
	}
	if err := sqlgraph.QueryNodes(ctx, slq.driver, _spec); err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nodes, nil
	}
	return nodes, nil
}

func (slq *SPDXLicenseQuery) sqlCount(ctx context.Context) (int, error) {
	_spec := slq.querySpec()
	return sqlgraph.CountNodes(ctx, slq.driver, _spec)
}

func (slq *SPDXLicenseQuery) sqlExist(ctx context.Context) (bool, error) {
	n, err := slq.sqlCount(ctx)
	if err != nil {
		return false, fmt.Errorf("ent: check existence: %w", err)
	}
	return n > 0, nil
}

func (slq *SPDXLicenseQuery) querySpec() *sqlgraph.QuerySpec {
	_spec := &sqlgraph.QuerySpec{
		Node: &sqlgraph.NodeSpec{
			Table:   spdxlicense.Table,
			Columns: spdxlicense.Columns,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: spdxlicense.FieldID,
			},
		},
		From:   slq.sql,
		Unique: true,
	}
	if unique := slq.unique; unique != nil {
		_spec.Unique = *unique
	}
	if fields := slq.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, spdxlicense.FieldID)
		for i := range fields {
			if fields[i] != spdxlicense.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, fields[i])
			}
		}
	}
	if ps := slq.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if limit := slq.limit; limit != nil {
		_spec.Limit = *limit
	}
	if offset := slq.offset; offset != nil {
		_spec.Offset = *offset
	}
	if ps := slq.order; len(ps) > 0 {
		_spec.Order = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return _spec
}

func (slq *SPDXLicenseQuery) sqlQuery(ctx context.Context) *sql.Selector {
	builder := sql.Dialect(slq.driver.Dialect())
	t1 := builder.Table(spdxlicense.Table)
	columns := slq.fields
	if len(columns) == 0 {
		columns = spdxlicense.Columns
	}
	selector := builder.Select(t1.Columns(columns...)...).From(t1)
	if slq.sql != nil {
		selector = slq.sql
		selector.Select(selector.Columns(columns...)...)
	}
	for _, p := range slq.predicates {
		p(selector)
	}
	for _, p := range slq.order {
		p(selector)
	}
	if offset := slq.offset; offset != nil {
		// limit is mandatory for offset clause. We start
		// with default value, and override it below if needed.
		selector.Offset(*offset).Limit(math.MaxInt32)
	}
	if limit := slq.limit; limit != nil {
		selector.Limit(*limit)
	}
	return selector
}

// SPDXLicenseGroupBy is the group-by builder for SPDXLicense entities.
type SPDXLicenseGroupBy struct {
	config
	fields []string
	fns    []AggregateFunc
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Aggregate adds the given aggregation functions to the group-by query.
func (slgb *SPDXLicenseGroupBy) Aggregate(fns ...AggregateFunc) *SPDXLicenseGroupBy {
	slgb.fns = append(slgb.fns, fns...)
	return slgb
}

// Scan applies the group-by query and scans the result into the given value.
func (slgb *SPDXLicenseGroupBy) Scan(ctx context.Context, v interface{}) error {
	query, err := slgb.path(ctx)
	if err != nil {
		return err
	}
	slgb.sql = query
	return slgb.sqlScan(ctx, v)
}

// ScanX is like Scan, but panics if an error occurs.
func (slgb *SPDXLicenseGroupBy) ScanX(ctx context.Context, v interface{}) {
	if err := slgb.Scan(ctx, v); err != nil {
		panic(err)
	}
}

// Strings returns list of strings from group-by.
// It is only allowed when executing a group-by query with one field.
func (slgb *SPDXLicenseGroupBy) Strings(ctx context.Context) ([]string, error) {
	if len(slgb.fields) > 1 {
		return nil, errors.New("ent: SPDXLicenseGroupBy.Strings is not achievable when grouping more than 1 field")
	}
	var v []string
	if err := slgb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// StringsX is like Strings, but panics if an error occurs.
func (slgb *SPDXLicenseGroupBy) StringsX(ctx context.Context) []string {
	v, err := slgb.Strings(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// String returns a single string from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (slgb *SPDXLicenseGroupBy) String(ctx context.Context) (_ string, err error) {
	var v []string
	if v, err = slgb.Strings(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{spdxlicense.Label}
	default:
		err = fmt.Errorf("ent: SPDXLicenseGroupBy.Strings returned %d results when one was expected", len(v))
	}
	return
}

// StringX is like String, but panics if an error occurs.
func (slgb *SPDXLicenseGroupBy) StringX(ctx context.Context) string {
	v, err := slgb.String(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Ints returns list of ints from group-by.
// It is only allowed when executing a group-by query with one field.
func (slgb *SPDXLicenseGroupBy) Ints(ctx context.Context) ([]int, error) {
	if len(slgb.fields) > 1 {
		return nil, errors.New("ent: SPDXLicenseGroupBy.Ints is not achievable when grouping more than 1 field")
	}
	var v []int
	if err := slgb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// IntsX is like Ints, but panics if an error occurs.
func (slgb *SPDXLicenseGroupBy) IntsX(ctx context.Context) []int {
	v, err := slgb.Ints(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Int returns a single int from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (slgb *SPDXLicenseGroupBy) Int(ctx context.Context) (_ int, err error) {
	var v []int
	if v, err = slgb.Ints(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{spdxlicense.Label}
	default:
		err = fmt.Errorf("ent: SPDXLicenseGroupBy.Ints returned %d results when one was expected", len(v))
	}
	return
}

// IntX is like Int, but panics if an error occurs.
func (slgb *SPDXLicenseGroupBy) IntX(ctx context.Context) int {
	v, err := slgb.Int(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64s returns list of float64s from group-by.
// It is only allowed when executing a group-by query with one field.
func (slgb *SPDXLicenseGroupBy) Float64s(ctx context.Context) ([]float64, error) {
	if len(slgb.fields) > 1 {
		return nil, errors.New("ent: SPDXLicenseGroupBy.Float64s is not achievable when grouping more than 1 field")
	}
	var v []float64
	if err := slgb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// Float64sX is like Float64s, but panics if an error occurs.
func (slgb *SPDXLicenseGroupBy) Float64sX(ctx context.Context) []float64 {
	v, err := slgb.Float64s(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64 returns a single float64 from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (slgb *SPDXLicenseGroupBy) Float64(ctx context.Context) (_ float64, err error) {
	var v []float64
	if v, err = slgb.Float64s(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{spdxlicense.Label}
	default:
		err = fmt.Errorf("ent: SPDXLicenseGroupBy.Float64s returned %d results when one was expected", len(v))
	}
	return
}

// Float64X is like Float64, but panics if an error occurs.
func (slgb *SPDXLicenseGroupBy) Float64X(ctx context.Context) float64 {
	v, err := slgb.Float64(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bools returns list of bools from group-by.
// It is only allowed when executing a group-by query with one field.
func (slgb *SPDXLicenseGroupBy) Bools(ctx context.Context) ([]bool, error) {
	if len(slgb.fields) > 1 {
		return nil, errors.New("ent: SPDXLicenseGroupBy.Bools is not achievable when grouping more than 1 field")
	}
	var v []bool
	if err := slgb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// BoolsX is like Bools, but panics if an error occurs.
func (slgb *SPDXLicenseGroupBy) BoolsX(ctx context.Context) []bool {
	v, err := slgb.Bools(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bool returns a single bool from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (slgb *SPDXLicenseGroupBy) Bool(ctx context.Context) (_ bool, err error) {
	var v []bool
	if v, err = slgb.Bools(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{spdxlicense.Label}
	default:
		err = fmt.Errorf("ent: SPDXLicenseGroupBy.Bools returned %d results when one was expected", len(v))
	}
	return
}

// BoolX is like Bool, but panics if an error occurs.
func (slgb *SPDXLicenseGroupBy) BoolX(ctx context.Context) bool {
	v, err := slgb.Bool(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

func (slgb *SPDXLicenseGroupBy) sqlScan(ctx context.Context, v interface{}) error {
	for _, f := range slgb.fields {
		if !spdxlicense.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("invalid field %q for group-by", f)}
		}
	}
	selector := slgb.sqlQuery()
	if err := selector.Err(); err != nil {
		return err
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := slgb.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

func (slgb *SPDXLicenseGroupBy) sqlQuery() *sql.Selector {
	selector := slgb.sql.Select()
	aggregation := make([]string, 0, len(slgb.fns))
	for _, fn := range slgb.fns {
		aggregation = append(aggregation, fn(selector))
	}
	// If no columns were selected in a custom aggregation function, the default
	// selection is the fields used for "group-by", and the aggregation functions.
	if len(selector.SelectedColumns()) == 0 {
		columns := make([]string, 0, len(slgb.fields)+len(slgb.fns))
		for _, f := range slgb.fields {
			columns = append(columns, selector.C(f))
		}
		for _, c := range aggregation {
			columns = append(columns, c)
		}
		selector.Select(columns...)
	}
	return selector.GroupBy(selector.Columns(slgb.fields...)...)
}

// SPDXLicenseSelect is the builder for selecting fields of SPDXLicense entities.
type SPDXLicenseSelect struct {
	*SPDXLicenseQuery
	// intermediate query (i.e. traversal path).
	sql *sql.Selector
}

// Scan applies the selector query and scans the result into the given value.
func (sls *SPDXLicenseSelect) Scan(ctx context.Context, v interface{}) error {
	if err := sls.prepareQuery(ctx); err != nil {
		return err
	}
	sls.sql = sls.SPDXLicenseQuery.sqlQuery(ctx)
	return sls.sqlScan(ctx, v)
}

// ScanX is like Scan, but panics if an error occurs.
func (sls *SPDXLicenseSelect) ScanX(ctx context.Context, v interface{}) {
	if err := sls.Scan(ctx, v); err != nil {
		panic(err)
	}
}

// Strings returns list of strings from a selector. It is only allowed when selecting one field.
func (sls *SPDXLicenseSelect) Strings(ctx context.Context) ([]string, error) {
	if len(sls.fields) > 1 {
		return nil, errors.New("ent: SPDXLicenseSelect.Strings is not achievable when selecting more than 1 field")
	}
	var v []string
	if err := sls.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// StringsX is like Strings, but panics if an error occurs.
func (sls *SPDXLicenseSelect) StringsX(ctx context.Context) []string {
	v, err := sls.Strings(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// String returns a single string from a selector. It is only allowed when selecting one field.
func (sls *SPDXLicenseSelect) String(ctx context.Context) (_ string, err error) {
	var v []string
	if v, err = sls.Strings(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{spdxlicense.Label}
	default:
		err = fmt.Errorf("ent: SPDXLicenseSelect.Strings returned %d results when one was expected", len(v))
	}
	return
}

// StringX is like String, but panics if an error occurs.
func (sls *SPDXLicenseSelect) StringX(ctx context.Context) string {
	v, err := sls.String(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Ints returns list of ints from a selector. It is only allowed when selecting one field.
func (sls *SPDXLicenseSelect) Ints(ctx context.Context) ([]int, error) {
	if len(sls.fields) > 1 {
		return nil, errors.New("ent: SPDXLicenseSelect.Ints is not achievable when selecting more than 1 field")
	}
	var v []int
	if err := sls.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// IntsX is like Ints, but panics if an error occurs.
func (sls *SPDXLicenseSelect) IntsX(ctx context.Context) []int {
	v, err := sls.Ints(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Int returns a single int from a selector. It is only allowed when selecting one field.
func (sls *SPDXLicenseSelect) Int(ctx context.Context) (_ int, err error) {
	var v []int
	if v, err = sls.Ints(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{spdxlicense.Label}
	default:
		err = fmt.Errorf("ent: SPDXLicenseSelect.Ints returned %d results when one was expected", len(v))
	}
	return
}

// IntX is like Int, but panics if an error occurs.
func (sls *SPDXLicenseSelect) IntX(ctx context.Context) int {
	v, err := sls.Int(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64s returns list of float64s from a selector. It is only allowed when selecting one field.
func (sls *SPDXLicenseSelect) Float64s(ctx context.Context) ([]float64, error) {
	if len(sls.fields) > 1 {
		return nil, errors.New("ent: SPDXLicenseSelect.Float64s is not achievable when selecting more than 1 field")
	}
	var v []float64
	if err := sls.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// Float64sX is like Float64s, but panics if an error occurs.
func (sls *SPDXLicenseSelect) Float64sX(ctx context.Context) []float64 {
	v, err := sls.Float64s(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64 returns a single float64 from a selector. It is only allowed when selecting one field.
func (sls *SPDXLicenseSelect) Float64(ctx context.Context) (_ float64, err error) {
	var v []float64
	if v, err = sls.Float64s(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{spdxlicense.Label}
	default:
		err = fmt.Errorf("ent: SPDXLicenseSelect.Float64s returned %d results when one was expected", len(v))
	}
	return
}

// Float64X is like Float64, but panics if an error occurs.
func (sls *SPDXLicenseSelect) Float64X(ctx context.Context) float64 {
	v, err := sls.Float64(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bools returns list of bools from a selector. It is only allowed when selecting one field.
func (sls *SPDXLicenseSelect) Bools(ctx context.Context) ([]bool, error) {
	if len(sls.fields) > 1 {
		return nil, errors.New("ent: SPDXLicenseSelect.Bools is not achievable when selecting more than 1 field")
	}
	var v []bool
	if err := sls.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// BoolsX is like Bools, but panics if an error occurs.
func (sls *SPDXLicenseSelect) BoolsX(ctx context.Context) []bool {
	v, err := sls.Bools(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bool returns a single bool from a selector. It is only allowed when selecting one field.
func (sls *SPDXLicenseSelect) Bool(ctx context.Context) (_ bool, err error) {
	var v []bool
	if v, err = sls.Bools(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{spdxlicense.Label}
	default:
		err = fmt.Errorf("ent: SPDXLicenseSelect.Bools returned %d results when one was expected", len(v))
	}
	return
}

// BoolX is like Bool, but panics if an error occurs.
func (sls *SPDXLicenseSelect) BoolX(ctx context.Context) bool {
	v, err := sls.Bool(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

func (sls *SPDXLicenseSelect) sqlScan(ctx context.Context, v interface{}) error {
	rows := &sql.Rows{}
	query, args := sls.sql.Query()
	if err := sls.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}
